/******************************************************************************
 *  This file is part of piconf.                                              *
 *                                                                            *
 *  Copyright (C) 2013  Rouven Spreckels  <nevuor@piconf.org>                 *
 *                                                                            *
 *  piconf is free software: you can redistribute it and/or modify            *
 *  it under the terms of the GNU Affero General Public License version 3 as  *
 *  published by the Free Software Foundation on 19 November 2007.            *
 *                                                                            *
 *  piconf is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU Affero General Public License for more details.                       *
 *                                                                            *
 *  You should have received a copy of the GNU Affero General Public License  *
 *  along with piconf.  If not, see <http://www.gnu.org/licenses/>.           *
 ******************************************************************************/

#ifndef _PICONF_M_H
#define _PICONF_M_H

#include "../piconf/piconf.hpp"
#include <iostream>
#include <termios.h>

namespace piconf {
	extern name_t name;
	class tag;
	class io_tag;
	class data_tag;
	typedef std::deque<std::string> lines_t;
	lines_t explode(line_t input, char delimiter = '\n', bool empty = true);
	lines_t indent(line_t front, lines_t::iterator begin, lines_t::iterator end);
	void lock_terminal(bool lock = true);
	void update_terminal(lines_t lines, std::ostream& ansi = std::cout);
}

#include "tag/tag.hpp"
#include "tag/data_tag.hpp"
#include "tag/io_tag.hpp"

#endif
