/******************************************************************************
 *  This file is part of piconf.                                              *
 *                                                                            *
 *  Copyright (C) 2013  Rouven Spreckels  <nevuor@piconf.org>                 *
 *                                                                            *
 *  piconf is free software: you can redistribute it and/or modify            *
 *  it under the terms of the GNU Affero General Public License version 3 as  *
 *  published by the Free Software Foundation on 19 November 2007.            *
 *                                                                            *
 *  piconf is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU Affero General Public License for more details.                       *
 *                                                                            *
 *  You should have received a copy of the GNU Affero General Public License  *
 *  along with piconf.  If not, see <http://www.gnu.org/licenses/>.           *
 ******************************************************************************/

#ifndef _PICONF_SHELL_TAG_
#define _PICONF_SHELL_TAG_

#include "shell_tag.hpp"
#include <vector>
#include <string>

piconf::shell_tag::shell_tag(pugi::xml_node node)
: data_tag(node) {
}

void piconf::shell_tag::parse_response(io_tag* io, pugi::xml_node node) {
	data_tag::parse_response(io, node);
	lines_t lines = explode(node.text().get());
	if (lines.size()) {
		io_box[io].result.push_back((std::string)"   "+node.path().c_str()+": "+lines[0]);
		if (lines.size() > 1) {
			lines = indent("           ", lines.begin()+1, lines.end());
			io_box[io].result.insert(io_box[io].result.end(), lines.begin(), lines.end());
		}
	}
}

void piconf::shell_tag::status(lines_t& lines) {
	lines.push_back(" Preparing shell: done.");
}

#endif
