/******************************************************************************
 *  This file is part of piconf.                                              *
 *                                                                            *
 *  Copyright (C) 2013  Rouven Spreckels  <nevuor@piconf.org>                 *
 *                                                                            *
 *  piconf is free software: you can redistribute it and/or modify            *
 *  it under the terms of the GNU Affero General Public License version 3 as  *
 *  published by the Free Software Foundation on 19 November 2007.            *
 *                                                                            *
 *  piconf is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU Affero General Public License for more details.                       *
 *                                                                            *
 *  You should have received a copy of the GNU Affero General Public License  *
 *  along with piconf.  If not, see <http://www.gnu.org/licenses/>.           *
 ******************************************************************************/

#ifndef _PICONF_TAG_
#define _PICONF_TAG_

#include "../piconfm.hpp"
#include "../../../vio/IO.hpp"
#include <string.h>
#include <arpa/inet.h>

piconf::tag::tag(pugi::xml_node node) {
	this->node = node;
	query = 0;
}

void piconf::tag::save() {
	std::ostringstream os;
	node.print(os);
	xml = os.str();
	size = htonl(xml.size()+1);
	delete[] query;
	query = new char[(sizeof size)+xml.size()+1];
	*((uint32_t*)query) = size;
	memcpy(query+sizeof size, xml.c_str(), xml.size()+1);
}

void piconf::tag::subscribe(std::deque<io_tag*>& io_box, bool inherit) {
}

void piconf::tag::handle(int code, std::string what) {
}

void piconf::tag::setup() {
}

void piconf::tag::schedule(const timespec* interval, const timespec* realtime, const timespec* accuracy) {
}

bool piconf::tag::process() {
	return false;
}

void piconf::tag::status(lines_t& lines) {
}

piconf::tag::~tag() {
	delete[] query;
}

#endif
