/******************************************************************************
 *  This file is part of piconf.                                              *
 *                                                                            *
 *  Copyright (C) 2013  Rouven Spreckels  <nevuor@piconf.org>                 *
 *                                                                            *
 *  piconf is free software: you can redistribute it and/or modify            *
 *  it under the terms of the GNU Affero General Public License version 3 as  *
 *  published by the Free Software Foundation on 19 November 2007.            *
 *                                                                            *
 *  piconf is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU Affero General Public License for more details.                       *
 *                                                                            *
 *  You should have received a copy of the GNU Affero General Public License  *
 *  along with piconf.  If not, see <http://www.gnu.org/licenses/>.           *
 ******************************************************************************/

#ifndef _PICONF_DATA_TAG_H
#define _PICONF_DATA_TAG_H

#include "tag.hpp"
#include <fstream>
#include <list>

namespace piconf {
	class data_tag;
}

class piconf::data_tag : public tag {
public:
	struct hooked_t {
		void (* process)();
		typedef std::list<VIO::IO*> ios_t;
		ios_t ios;
	};
protected:
	typedef uint8_t state_t;
	state_t state;
	static const state_t
	RESPOND    = 0x01,
	RESPONDING = 0x02;
	VIO::IO* io;
	std::string xml;
	uint32_t size;
	char* value;
	std::ofstream* log;
	data_tag(std::ofstream& log, pugi::xml_node tag, VIO::IO* io);
	void respond();
	pugi::xml_node tag;
	static hooked_t::ios_t queued;
public:
	virtual bool hook_me_up();
	static hooked_t::ios_t& hook_me_down();
	virtual bool process();
	virtual ~data_tag();
};

#endif
