/******************************************************************************
 *  This file is part of piconf.                                              *
 *                                                                            *
 *  Copyright (C) 2013  Rouven Spreckels  <nevuor@piconf.org>                 *
 *                                                                            *
 *  piconf is free software: you can redistribute it and/or modify            *
 *  it under the terms of the GNU Affero General Public License version 3 as  *
 *  published by the Free Software Foundation on 19 November 2007.            *
 *                                                                            *
 *  piconf is distributed in the hope that it will be useful,                 *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of            *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             *
 *  GNU Affero General Public License for more details.                       *
 *                                                                            *
 *  You should have received a copy of the GNU Affero General Public License  *
 *  along with piconf.  If not, see <http://www.gnu.org/licenses/>.           *
 ******************************************************************************/

#ifndef _PICONF_FILE_TAG_H
#define _PICONF_FILE_TAG_H

#include "data_tag.hpp"
#include "../../../vio/File.hpp"

namespace piconf {
	class file_tag;
}

class piconf::file_tag : public data_tag {
	pugi::xml_node tpl;
	typedef uint8_t file_state_t;
	file_state_t file_state;
	static const file_state_t
	READING_FILE = 0x01,
	WRITING_FILE = 0x02,
	INVALID      = 0x04,
	DONE         = 0x08,
	READBACK     = 0x10;
	char* file_buff;
	size_t file_size;
	VIO::File file;
public:
	file_tag(std::ofstream& log, pugi::xml_node tpl, pugi::xml_node tag, VIO::IO* io);
	bool process();
	~file_tag();
};

#endif
